---------------------------------------------------------------------------------------------------
-- DEEDS (Digital Electronics Education and Design Suite)
-- VHDL Code generated on (12/21/2014, 7:32:41 PM)
--      by the Digital Circuit Simulator(d-DcS)
--      Ver. 1.80.100 (March 21, 2014)
-- Copyright(c)2002-2014 University of Genoa, Italy
--      Web Site:  http://www.esng.dibe.unige.it/deeds
---------------------------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.all;


ENTITY ByteGenerator IS
  PORT( 
    ---------------------------------------------------------------------------------> Inputs:
    inReset:      IN  std_logic;
    Microcomputer_Module: IN  std_logic;
    inDown:       IN  std_logic;
    inUp:         IN  std_logic;
    ---------------------------------------------------------------------------------> Outputs:
    oBYTE_hexu:   OUT std_logic_vector( 7 downto 0 );
    oBYTE_binu:   OUT std_logic_vector( 7 downto 0 );
    oError:       OUT std_logic 
    ---------------------------------------------------------------------------------
    );
END ByteGenerator;


ARCHITECTURE structural OF ByteGenerator IS 

  ----------------------------------------------------------------------------------> DMC8 Micro Computer(s):
  COMPONENT Microcomputer_Module IS
    PORT( 
          CK    : IN std_logic;	-- Actually not "On Board"!
          nRESET: IN std_logic;
          nINT  : IN std_logic;
          --
          CKOUT : OUT std_logic;
          nRSOUT: OUT std_logic;
          nINTA : OUT std_logic;
          nSYNC : OUT std_logic;	-- PIN 7
          --
          nRA   : OUT std_logic;
          IA0   : IN std_logic;
          IA1   : IN std_logic;
          IA2   : IN std_logic;
          IA3   : IN std_logic;
          IA4   : IN std_logic;
          IA5   : IN std_logic;
          IA6   : IN std_logic;
          IA7   : IN std_logic;	-- PIN 16
          --
          nRB   : OUT std_logic;
          IB0   : IN std_logic;
          IB1   : IN std_logic;
          IB2   : IN std_logic;
          IB3   : IN std_logic;
          IB4   : IN std_logic;
          IB5   : IN std_logic;
          IB6   : IN std_logic;
          IB7   : IN std_logic;	-- PIN 25
          --
          nRC   : OUT std_logic;
          IC0   : IN std_logic;
          IC1   : IN std_logic;
          IC2   : IN std_logic;
          IC3   : IN std_logic;
          IC4   : IN std_logic;
          IC5   : IN std_logic;
          IC6   : IN std_logic;
          IC7   : IN std_logic;	-- PIN 34
          --
          nRD   : OUT std_logic;
          ID0   : IN std_logic;
          ID1   : IN std_logic;
          ID2   : IN std_logic;
          ID3   : IN std_logic;
          ID4   : IN std_logic;
          ID5   : IN std_logic;
          ID6   : IN std_logic;
          ID7   : IN std_logic;	-- PIN 43
          --
          nWA   : OUT std_logic;
          OA0   : OUT std_logic;
          OA1   : OUT std_logic;
          OA2   : OUT std_logic;
          OA3   : OUT std_logic;
          OA4   : OUT std_logic;
          OA5   : OUT std_logic;
          OA6   : OUT std_logic;
          OA7   : OUT std_logic;	-- PIN 52
          --
          nWB   : OUT std_logic;
          OB0   : OUT std_logic;
          OB1   : OUT std_logic;
          OB2   : OUT std_logic;
          OB3   : OUT std_logic;
          OB4   : OUT std_logic;
          OB5   : OUT std_logic;
          OB6   : OUT std_logic;
          OB7   : OUT std_logic;	-- PIN 61
          --
          nWC   : OUT std_logic;
          OC0   : OUT std_logic;
          OC1   : OUT std_logic;
          OC2   : OUT std_logic;
          OC3   : OUT std_logic;
          OC4   : OUT std_logic;
          OC5   : OUT std_logic;
          OC6   : OUT std_logic;
          OC7   : OUT std_logic;	-- PIN 70
          --
          nWD   : OUT std_logic;
          OD0   : OUT std_logic;
          OD1   : OUT std_logic;
          OD2   : OUT std_logic;
          OD3   : OUT std_logic;
          OD4   : OUT std_logic;
          OD5   : OUT std_logic;
          OD6   : OUT std_logic;
          OD7   : OUT std_logic;  -- PIN 79
          --
          NRES  : OUT std_logic;	-- Reset debug output
          STEP  : OUT std_logic;	-- Step by Step output
          S0		: IN	std_logic;	-- CPU register selection (5 bits + nibble)
          S1		: IN	std_logic;
          S2		: IN	std_logic;
          S3		: IN	std_logic;
          S4		: IN	std_logic;
          Ni		: IN	std_logic;
          R0		: OUT std_logic;
          R1		: OUT std_logic;
          R2		: OUT std_logic;
          R3		: OUT std_logic
          );
  END COMPONENT;
  --
  ----------------------------------------------------------------------------------> Signals:
  SIGNAL S001: std_logic;
  SIGNAL S002: std_logic;
  SIGNAL S003: std_logic;
  SIGNAL S004: std_logic;
  SIGNAL S005: std_logic;
  SIGNAL S006: std_logic;
  SIGNAL S007: std_logic;
  SIGNAL S008: std_logic;
  SIGNAL S009: std_logic;
  SIGNAL S010: std_logic;
  SIGNAL S011: std_logic;
  SIGNAL S012: std_logic;
  SIGNAL S013: std_logic;
  SIGNAL S014: std_logic;

  ----------------------------------------------------------------------------------> Not Connected Pins:
  SIGNAL nc164p4: std_logic;
  SIGNAL nc164p5: std_logic;
  SIGNAL nc164p6: std_logic;
  SIGNAL nc164p7: std_logic;
  SIGNAL nc164p8: std_logic;
  SIGNAL nc164p17: std_logic;
  SIGNAL nc164p18: std_logic;
  SIGNAL nc164p19: std_logic;
  SIGNAL nc164p20: std_logic;
  SIGNAL nc164p21: std_logic;
  SIGNAL nc164p22: std_logic;
  SIGNAL nc164p23: std_logic;
  SIGNAL nc164p24: std_logic;
  SIGNAL nc164p25: std_logic;
  SIGNAL nc164p26: std_logic;
  SIGNAL nc164p27: std_logic;
  SIGNAL nc164p28: std_logic;
  SIGNAL nc164p29: std_logic;
  SIGNAL nc164p30: std_logic;
  SIGNAL nc164p31: std_logic;
  SIGNAL nc164p32: std_logic;
  SIGNAL nc164p33: std_logic;
  SIGNAL nc164p34: std_logic;
  SIGNAL nc164p35: std_logic;
  SIGNAL nc164p36: std_logic;
  SIGNAL nc164p37: std_logic;
  SIGNAL nc164p38: std_logic;
  SIGNAL nc164p39: std_logic;
  SIGNAL nc164p40: std_logic;
  SIGNAL nc164p41: std_logic;
  SIGNAL nc164p42: std_logic;
  SIGNAL nc164p43: std_logic;
  SIGNAL nc164p44: std_logic;
  SIGNAL nc164p45: std_logic;
  SIGNAL nc164p46: std_logic;
  SIGNAL nc164p47: std_logic;
  SIGNAL nc164p48: std_logic;
  SIGNAL nc164p49: std_logic;
  SIGNAL nc164p50: std_logic;
  SIGNAL nc164p51: std_logic;
  SIGNAL nc164p52: std_logic;
  SIGNAL nc164p53: std_logic;
  SIGNAL nc164p54: std_logic;
  SIGNAL nc164p55: std_logic;
  SIGNAL nc164p56: std_logic;
  SIGNAL nc164p57: std_logic;
  SIGNAL nc164p58: std_logic;
  SIGNAL nc164p59: std_logic;
  SIGNAL nc164p60: std_logic;
  SIGNAL nc164p61: std_logic;
  SIGNAL nc164p62: std_logic;
  SIGNAL nc164p71: std_logic;
  SIGNAL nc164p72: std_logic;
  SIGNAL nc164p73: std_logic;
  SIGNAL nc164p74: std_logic;
  SIGNAL nc164p75: std_logic;
  SIGNAL nc164p76: std_logic;
  SIGNAL nc164p77: std_logic;
  SIGNAL nc164p78: std_logic;


BEGIN -- structural

  ----------------------------------------------------------------------------------> Input:
  S001 <= inReset;
  S014 <= inDown;
  S013 <= inUp;

  ----------------------------------------------------------------------------------> Output:
  oBYTE_hexu(0) <= S003;
  oBYTE_hexu(1) <= S010;
  oBYTE_hexu(2) <= S004;
  oBYTE_hexu(3) <= S005;
  oBYTE_hexu(4) <= S006;
  oBYTE_hexu(5) <= S007;
  oBYTE_hexu(6) <= S008;
  oBYTE_hexu(7) <= S009;
  oBYTE_binu(0) <= S003;
  oBYTE_binu(1) <= S010;
  oBYTE_binu(2) <= S004;
  oBYTE_binu(3) <= S005;
  oBYTE_binu(4) <= S006;
  oBYTE_binu(5) <= S007;
  oBYTE_binu(6) <= S008;
  oBYTE_binu(7) <= S009;
  oError <= S011;

  ----------------------------------------------------------------------------------> Constants:
  S002 <= '0';
  S012 <= '1';

  ----------------------------------------------------------------------------------> Component Mapping:
  C164: Microcomputer_Module PORT MAP ( Clk_Microcomputer_Module, 
                                        S001, S012, nc164p4, 
                                        nc164p5, nc164p6, nc164p7, 
                                        nc164p8, S014, S013, 
                                        S002, S002, S002, S002, 
                                        S002, S002, nc164p17, 
                                        nc164p18, nc164p19, nc164p20, 
                                        nc164p21, nc164p22, nc164p23, 
                                        nc164p24, nc164p25, nc164p26, 
                                        nc164p27, nc164p28, nc164p29, 
                                        nc164p30, nc164p31, nc164p32, 
                                        nc164p33, nc164p34, nc164p35, 
                                        nc164p36, nc164p37, nc164p38, 
                                        nc164p39, nc164p40, nc164p41, 
                                        nc164p42, nc164p43, nc164p44, 
                                        nc164p45, nc164p46, nc164p47, 
                                        nc164p48, nc164p49, nc164p50, 
                                        nc164p51, nc164p52, nc164p53, 
                                        nc164p54, nc164p55, nc164p56, 
                                        nc164p57, nc164p58, nc164p59, 
                                        nc164p60, nc164p61, nc164p62, 
                                        S003, S010, S004, S005, 
                                        S006, S007, S008, S009, 
                                        nc164p71, nc164p72, nc164p73, 
                                        nc164p74, nc164p75, nc164p76, 
                                        nc164p77, nc164p78, S011, 
                                        DR_Microcomputer_Module, 
                                        SS_Microcomputer_Module, 
                                        S0_Microcomputer_Module, 
                                        S1_Microcomputer_Module, 
                                        S2_Microcomputer_Module, 
                                        S3_Microcomputer_Module, 
                                        S4_Microcomputer_Module, 
                                        Ni_Microcomputer_Module, 
                                        R0_Microcomputer_Module, 
                                        R1_Microcomputer_Module, 
                                        R2_Microcomputer_Module, 
                                        R3_Microcomputer_Module );

END structural;
